/////////////////////////////////////////////////////////////////////////////////
//
// Thor C++ Library
// Copyright (c) 2011-2022 Jan Haller
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//
/////////////////////////////////////////////////////////////////////////////////

namespace thor
{

template <typename T>
std::string toString(const sf::Vector2<T>& vector)
{
	std::ostringstream stream;
	stream << '(' << vector.x << ',' << vector.y << ')';
	return stream.str();
}

template <typename T>
std::string toString(const sf::Vector3<T>& vector)
{
	std::ostringstream stream;
	stream << '(' << vector.x << ',' << vector.y << ',' << vector.z << ')';
	return stream.str();
}

template <typename T>
std::string toString(const sf::Rect<T>& rect)
{
	std::ostringstream stream;
	stream << '(' << rect.left << ',' << rect.top << ';' << rect.width << ',' << rect.height << ')';
	return stream.str();
}

template <typename T>
std::string toString(const PolarVector2<T>& vector)
{
	std::ostringstream stream;
	stream << "(" << vector.r << "," << vector.phi << "\x00B0)";
	return stream.str();
}

} // namespace thor
